<script>
  import Radio from "./radio.svelte";
  import Input from "./input.svelte";

  let disabled = false;
  let message = "";
  let messageClass = "";
  let formClass = "";
  let otherClass = "";

  const age = [
    { label: "25-35", value: "25-35" },
    { label: "36-50", value: "36-50" },
    { label: "50+", value: "50+" }
  ];

  const exposure = [
    { label: "Facebook", value: "facebook" },
    { label: "In-Store", value: "store" },
    { label: "Friends", value: "friend" },
    { label: "Walk-In", value: "walk" },
    { label: "Local", value: "local" },
    { label: "Other", value: "other" }
  ];

  const purchase = [
    { label: "Online", value: "online" },
    { label: "Phone", value: "phone" },
    { label: "In-Store", value: "store" }
  ];

  const gender = [
    { label: "Male", value: "male" },
    { label: "Female", value: "female" }
  ];

  const _125 = [
    { label: "1", value: "1" },
    { label: "2", value: "2" },
    { label: "3", value: "3" },
    { label: "4", value: "4" },
    { label: "5", value: "5" }
  ];
  const yn = [{ label: "Yes", value: "Yes" }, { label: "No", value: "No" }];

  const submit = e => {
    e.preventDefault();

    disabled = true;

    let form = new FormData(document.querySelector("form"));

    const data = {};
    form.forEach((value, key) => (data[key] = value));

    fetch("https://api.wildwoodhealth.org/frm/entries", {
      method: "POST",
      headers: {
        "Content-Type": "application/json"
      },
      body: JSON.stringify(data)
    })
      .then(r => r.json())
      .then(r => (r.status == 200 ? success() : error(r)))
      .catch(error);

    return false;
  };

  const success = () => {
    window.scrollTo(0, 0);
    message = "Thank you for your submission";
    formClass = "success";

    setTimeout(() => {
      location.reload();
    }, 1000);
  };

  const error = e => {
    disabled = false;
    message = "There was an error submitting your response";
    messageClass = "error";
    console.error(e);
  };
</script>

<style>
  main {
    min-height: 100vh;
    box-sizing: border-box;
    display: flex;
    flex-flow: column nowrap;
    justify-content: center;
    align-items: center;
    padding: 40px;
  }
  #message {
    color: #fff;
    padding: 20px;
    margin: 0 0 30px;
    border-radius: 3px;
  }
  #message.error {
    background: #ff6961;
  }
  form {
    opacity: 1;
    transition: 500ms;
  }
  form.success {
    opacity: 0;
  }

  .row {
    margin-bottom: 30px;
  }
  .grid {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-gap: 20px;
  }

  .grid .label {
    grid-column: span 2;
    margin: 0;
  }

  .frow {
    display: grid;
    grid-template-columns: repeat(var(--count), 1fr);
    grid-gap: 20px;
  }

  .frow .label {
    grid-column: 1/-1;
    margin: 0;
  }

  .span {
    grid-column: span 2;
  }
</style>

<main>
  <h1>Customer Survey</h1>
  <form action="post.php" method="POST" on:submit={submit} class={formClass}>
    <p id="message" class={messageClass}>{message}</p>
    <div class="row frow" style="--count:3">
      <p class="label">Age</p>
      <Radio name="378" options={age} {disabled} />
    </div>
    <div class="row grid">
      <p class="label">Gender</p>
      <Radio name="370" options={gender} {disabled} />
    </div>
    <div class="row grid">
      <p class="label">First time at store</p>
      <Radio name="371" options={yn} {disabled} />
    </div>
    <div class="row grid">
      <p class="label">Exposure*</p>
      <Radio name="372" options={exposure} {disabled} required="true" />
    </div>
    <div class="row">
      <Input
        label="Customer Total"
        type="number"
        name="373"
        placeholder="0.00"
        {disabled} />
    </div>
    <div class="row grid">
      <p class="label">Preferred purchase method</p>
      <Radio name="374" options={purchase} {disabled} />
    </div>

    <div class="row frow" style="--count:5">
      <p class="label">Experience</p>
      <Radio name="375" options={_125} {disabled} />
    </div>

    <div class="row">
      <Input label="Email" type="email" name="376" {disabled} />
    </div>
    <div class="row">
      <Input label="Name" type="text" name="377" {disabled} />
    </div>

    <input type="hidden" name="target" value="wildwoodhealth.org" />
    <input type="hidden" name="form_id" value="24" />
    <Input type="submit" value="Submit" {disabled} />
  </form>
</main>
